package testobjectdb;

import java.io.File;

import javax.persistence.EntityManager;


public class Main {

  public static void main(String[] args) {
    mainTest();
  }

  public static void mainTest() {
    Main.deleteFileSafely(Main.TMP_TEST_ODB);
    Main.deleteFileSafely(Main.TMP_TEST_ODB + "$");
  
    new WithTransaction() {
      @Override
      void body(EntityManager em) {
        Parent parent = new Parent();
        parent.name = Main.PARENT_ID;
        em.persist(parent);
        
        Child child = new Child();
        child.rn = Main.CHILD_ID;
        child.prn = parent;
        em.persist(child);
        System.out.println("Parent reference written: " + child.prn);
      }
    }.run();
  
    new WithTransaction() {
      @Override
      void body(EntityManager em) {
        Child child = em.find(Child.class, Main.CHILD_ID);
        System.out.println("Parent reference read back: " + child.prn);
      }
    }.run();
  
  }

  public static void deleteFileSafely(String file) {
    File dbFile = new File(file);
    if(dbFile.exists())
      dbFile.delete();
  }

  static final String CHILD_ID = "some_child_id";
  static final String PARENT_ID = "some_parent_id";
  static final String TMP_TEST_ODB = "/tmp/test.odb";

}
